// @TOOD change this file name
<template>
  <div id="card-handling-form">
    <button class="btn btn-primary" type="button" @click=on_browse>Przeglądaj</button>
    <br/>
    <br/>
    jzot:
    <select
      v-if="!card_handling_object.header_approved"
      name="jzot"
      id="jzot"
      v-model="card_handling_object.jzot"
      @change="jzotChanged($event)"
    >
      <option value="null" disabled>jzot</option>
      <option v-for="jzot in jzot_list" :key="jzot.id" :value="jzot.id">{{jzot.point_number}}->{{jzot.specialization_serialized.name}}</option>
    </select>

    <div v-if="!card_handling_object.header_approved">
    estymowane roboczogodziny:
      <input type="number" v-model="card_handling_object.effort_hours" placeholder="effort hours" />
    </div>
    rzeczywiste roboczogodziny:
    <input type="number" v-model="card_handling_object.man_hours" placeholder="man hours" />

    wykonawcy:
    <select
      name="executors"
      id="executors"
      :disabled=user_select_disabled
      v-model="card_handling_object.executors"
      @change="specChanged"
      multiple
    >
      <option value="null" disabled>executors</option>
      <option v-for="executor in executors_list" :key="executor.id" :value="executor.id">{{executor.name.first_name}}  {{executor.name.last_name}}</option>
    </select>

    <div v-if="user_type == 'SquadronCommander'">
      nadzorujący:
      <select
        name="supervisier"
        id="supervisier"
        :disabled="user_select_disabled"
        v-model="card_handling_object.supervisier"
        @change="specChanged"
      >
        <option value="null" disabled>supervisier</option>
        <option v-for="supervisier in supervisors_list" :key="supervisier.id" :value="supervisier.id">{{supervisier.name.first_name}}  {{supervisier.name.last_name}}</option>
      </select>
    </div>

    <button @click="CreateCardHandling">{{submit_text}}</button>

    <span id="error_message">{{error_message}}</span>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { createDataBaseObject, putDataBaseObject, getJzot, getCardHeader, getExecutorsPartial, getSupervisorsPartial} from "../../utils/apiUtils";
import router from "../../router";

const card_handlings_url = "http://127.0.0.1:8000/handlings/card_handlings/";

export default {
  // @TODO tylko staff może dodawać Card Handling, automatycznie ustawić staffa - ten co dodaje rekord jest staffem
  // Staff dodaje tez executorów, ale executorzy muszą mieć możliwość potwerdzenia, że są/ byli executorami,
  // executor moze tylko siebie potwierdzić
  // nie potwierdzeni executorzy beda wysfietlatni na czerwono, a potwerdzeni na zielono

  // @TODO Executor na stronie startowej ma rzeczy do potwierdzenia

  // @TODO Superviser na stronie starowej powinien miec Card Headers

  // @TODO Dodać 3 poziomy uprawnien: admin - ma dostęp do wszystkich tabel
  //                                  staff - może być supervisorem może dodawać Card Handlings (nie może edytować)
  //                                  executioner - może powierdzić, że jest executionerm danego Card Handlings

  // @TODO po zarejestrowaniu admin musi potweridzic uzytkownika, nie potwierdzony uzytkownik nie może się zalogować - uzyj pola isActive
  // @TODO admin na stronie startowej ma listę uzytkowników do potwierdzenia


  // @TODO Uniemożliwić wybranie nie spójnych danych:
  // - jzot tylko z takim samym poziomem obsług co karta nagłówek
  // - jzot tylko z takim samym statkiem powietrznym co karta nagłówek
  // - jzot tylko z taka sama specjalizacja jak nadzorca i wykonawcy
  name: "CardHandlingCreate",
  props: {
    initial_object : Object,
    id : String,
    after_post_callback : Function,
    on_browse : Function,
    header_id : String,
    handling_id : String,
    airship_type_id : String,
    user_type : String
  },
  data: function() {
    return {
      card_handling_object:{
          header: this.header_id,
          jzot: null,
          effort_hours: null,
          man_hours: null,
          finish_date: null,
          executors: [],
          supervisier: null,
          header_approved: null
      },

      jzot_list: [],
      supervisors_list: [],
      executors_list: [],

      submit_text: "Create",
      user_select_disabled: true,
      error_message: ""
    };
  },
  methods: {
    CardHandlingObjectClear() {
        this.card_handling_object = {
          header: this.header_id,
          jzot: null,
          effort_hours: null,
          man_hours: null,
          finish_date: null,
          executors: [],
          supervisier: null
      };
    },
    CreateCardHandling() {
        (async () => {
            try {
              if (this.submit_text == "Create") {
                console.log("card handling object:", this.card_handling_object);
                await createDataBaseObject(card_handlings_url, this.card_handling_object, "card_handling");
                this.CardHandlingObjectClear();
              } else if (this.submit_text == "Edit") {
                await putDataBaseObject(card_handlings_url + this.initial_object.id + "/", this.card_handling_object, "card_handling");
              }
              this.after_post_callback?.();
            } catch (error) {
                this.error_message = error;
            }
        })();
    },
    // show only this executors and supervisiers, which matches to selected jzot
    jzotChanged(event) {
      // We need this only for SquadronCommander,
      // because only this user type can add handlings with any specialization
      if (this.user_type != 'SquadronCommander') {
        return;
      }

      let jzot = this.jzot_list.filter(element => element.id == event.target.value)[0];
      let specialization = jzot.specialization_serialized.id.toString();

      (async () => {
          setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
          this.supervisors_list = await getSupervisorsPartial(specialization);
          this.executors_list = await getExecutorsPartial(specialization);
          this.user_select_disabled = false
      })();
    },
    specChanged() {},
  },

  mounted: function() {
    let specialization = null
    // show only this jzot, which are consistent with handlings header
    const jzot_params = {
        filters: {
          airship_type: JSON.stringify([this.airship_type_id]),
          handlings_level: JSON.stringify([this.handling_id])
          }
        };

    if (this.initial_object) {
      let executors = this.initial_object?.execute_set.map(function(x) {return x.executor_partial_serialized.id})

      this.card_handling_object = this.initial_object;
      this.card_handling_object.executors = executors ? executors : [];
      this.submit_text = "Edit";
    }

    if (this.user_type == 'KeyCommander') {
      this.user_select_disabled = false
      if (!this.card_handling_object.supervisier) {
        this.card_handling_object.supervisier = this.$store.state.user.extended_user.id;
      }

      // KeyCommander is able to add handling with jzot and executor with the same specialization as his. 
      specialization = this.$store.state.user.extended_user.specialization.toString();
      jzot_params.filters.specialization = JSON.stringify([specialization]);
    }

    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.jzot_list = await getJzot(jzot_params);
        this.supervisors_list = await getSupervisorsPartial();
        this.executors_list = await getExecutorsPartial(specialization);
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
#card-handling-form {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-left: 40%;
  margin-right: 40%;
}
input {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
select {
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  border: 1px solid #ccc;
  border-radius: 4px;
  box-sizing: border-box;
  text-align: center;
}
#error_message {
  color: red;
}
</style>>